#include <vector_types.h>
#include "auxcuda.h"

template <>
cudaChannelFormatDesc makeCudaChannelFormatDesc<unsigned char> () {
    const cudaChannelFormatDesc format = {8, 0, 0, 0, cudaChannelFormatKindUnsigned};
    return format;
}

template <>
cudaChannelFormatDesc makeCudaChannelFormatDesc<unsigned short> () {
    const cudaChannelFormatDesc format = {16, 0, 0, 0, cudaChannelFormatKindUnsigned};
    return format;
}

template <>
cudaChannelFormatDesc makeCudaChannelFormatDesc<unsigned int> () {
    const cudaChannelFormatDesc format = {32, 0, 0, 0, cudaChannelFormatKindUnsigned};
    return format;
}


template <>
cudaChannelFormatDesc makeCudaChannelFormatDesc<float> () {
    const cudaChannelFormatDesc format = {32, 0, 0, 0, cudaChannelFormatKindFloat};
    return format;
}

template <>
cudaChannelFormatDesc makeCudaChannelFormatDesc<uchar4> () {
    const cudaChannelFormatDesc format = {8, 8, 8, 8, cudaChannelFormatKindUnsigned};
    return format;
}

template <>
cudaChannelFormatDesc makeCudaChannelFormatDesc<ushort4> () {
    const cudaChannelFormatDesc format = {16, 16, 16, 16, cudaChannelFormatKindUnsigned};
    return format;
}

template <>
cudaChannelFormatDesc makeCudaChannelFormatDesc<uint4> () {
    const cudaChannelFormatDesc format = {32, 32, 32, 32, cudaChannelFormatKindUnsigned};
    return format;
}

template <>
cudaChannelFormatDesc makeCudaChannelFormatDesc<int4> () {
    const cudaChannelFormatDesc format = {32, 32, 32, 32, cudaChannelFormatKindSigned};
    return format;
}

template <>
cudaChannelFormatDesc makeCudaChannelFormatDesc<float4> () {
    const cudaChannelFormatDesc format = {32, 32, 32, 32, cudaChannelFormatKindFloat};
    return format;
}
