#ifndef COMPILETIMECONFIG_H
#define COMPILETIMECONFIG_H

/// These are the parameters for the histogram-based sigma estimation.
/// We think they should not need to be changed often, hence their
/// inclusion in this header rather than the config file.
const unsigned int NUMBINS = 20; // This MUST be < 255. Not that it makes sense to use that many bins, anyway.
const float MINDIFF = 0.001f; // This is the lower bound of the logscale for the histogram
const float MAXDIFF = 1.0f; // This is the upper bound of the logscale for the histogram

#endif // COMPILETIMECONFIG_H

