#ifndef IOCONFIG_H
#define IOCONFIG_H

#include <iostream>

class IOConfig {
public:
    IOConfig (void) {}

    IOConfig& setInputDir  (const std::string& id);
    IOConfig& setOutputDir (const std::string& od);
    IOConfig& setFilenameTemplate (const std::string& fnt);
    IOConfig& setFirstFrameNumber (int ffn);
    IOConfig& setLastFrameNumber (int lfn);
    IOConfig& setOutputBufferSize (unsigned int obs);
    IOConfig& setSaveForegroundPDF (bool sfgpdf);
    IOConfig& setSaveBackgroundPDF (bool sbgpdf);
    IOConfig& setSaveForegroundProbability (bool sfgp);
    IOConfig& setSaveForegroundDetection (bool sfd);
    IOConfig& setSavePNG (bool savePNG);

    IOConfig (const IOConfig& other);

    std::string inputDir;
    std::string outputDir;
    std::string filenameTemplate;
    int first;
    int last;
    unsigned int outputBufferSize;
    bool saveForegroundPDF;
    bool saveBackgroundPDF;
    bool saveForegroundProbability;
    bool saveForegroundDetection;
    bool savePNG;
};

std::ostream & operator<< (std::ostream & o, IOConfig io);


#endif // IOCONFIG_H
