#ifndef PROCESSINGCONFIG_H
#define PROCESSINGCONFIG_H

#include <iostream>

//extern "C" {
    struct ProcessingConfig/* : ProcessingConfigModes*/ {
        enum ColourSpace {RGB,
                          RnGnGradS};
        ColourSpace colourSpace;
        unsigned char colourDepth;
        int   referenceBufferSize; // Size in frames of the reference buffer

        int   backgroundReferenceFrames; // Number of reference frames for BG
        bool  backgroundAppearanceSigmaEstimation;
        int   backgroundAppearanceSigmaEstimationDelay; // Number of past frames necessary before estimating sigma
        float backgroundAppearanceSigmaEstimationMinimum; // Minimum value for estimated sigma
        float backgroundAppearanceSigmaEstimationMaximum; // Maximum value for estimated sigma
        float backgroundAppearanceSigma; // Fixed sigma for appearance in BG
        bool  backgroundSpatialModelling;
        float backgroundSpatialSigma; // Fixed sigma for space in BG
        float backgroundInverseSpatialSigma; // 1.0 / backgroundSpatialSigma
        int   backgroundSpatialRadius; // Spatial search radius for BG model
        bool  backgroundSelectiveUpdate;
        int   backgroundSelectiveUpdateCutoff; // Cutoff in frames for selective update mechanism (?)
        float backgroundSelectiveUpdateSigmaTsquare; // Squared sigma for selective update mechanism

        bool  foregroundModelEnabled;
        int   foregroundStartDelay; // Number of past frames necessary before starting the model
        int   foregroundReferenceFrames; // Number of reference frames for FG
        float foregroundAppearanceSigma; // Fixed sigma for appearance in FG
        bool  foregroundUseBGAppearanceSigma;
        float foregroundBGAppearanceSigmaMultiplier;
        bool  foregroundSpatialModelling;
        float foregroundSpatialSigma; // Fixed sigma for space in FG
        int   foregroundSpatialRadius; // Spatial search radius for FG model
        float foregroundMixingFactor;

        bool  particleFilterEnabled;
        unsigned int particleFilterMaxRegions; // Max. number of regions to be considered by the filter
        unsigned int particleFilterMinRegionSize; // Min. size in pixels of a region to be considered
        unsigned int particleFilterMaxParticles;
        float particleFilterMinParticleRadius; // minParticleRadius MUST be > 0
        float particleFilterMaxParticleRadius;//200.0f;
        float particleFilterParticleLikelihoodBeta;
        float particleFilterRandomCentreJitter; // Jitter in pixels that will be applied wrt the parent state vector when creating new particles
        float particleFilterRandomSizeFactor; // Size of new particles will be between 0 and this value times the size of the parent state vector
        bool  particleFilterComputeFGPrior;




        bool  roiAnalysis;
        int   blockWidth;
        int   blockHeight;

        bool  morphologicalFilter;

        bool  spatialMarginalConditioning;
    } /*ProcessingConfigStruct*/;
//}

    std::ostream & operator<< (std::ostream & o, ProcessingConfig p);

#endif
